## lua-torch-image 0~20170420

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.6 FATAL_ERROR)
CMAKE_POLICY(VERSION 2.6)

FIND_PACKAGE(Torch REQUIRED)
FIND_PACKAGE(JPEG)
FIND_PACKAGE(PNG)

# OpenMP support?
SET(WITH_OPENMP ON CACHE BOOL "OpenMP support if available?")
IF (APPLE AND CMAKE_COMPILER_IS_GNUCC)
  EXEC_PROGRAM (uname ARGS -v  OUTPUT_VARIABLE DARWIN_VERSION)
  STRING (REGEX MATCH "[0-9]+" DARWIN_VERSION ${DARWIN_VERSION})
  MESSAGE (STATUS "MAC OS Darwin Version: ${DARWIN_VERSION}")
  IF (DARWIN_VERSION GREATER 9)
    SET(APPLE_OPENMP_SUCKS 1)
  ENDIF (DARWIN_VERSION GREATER 9)
  EXECUTE_PROCESS (COMMAND ${CMAKE_C_COMPILER} -dumpversion
    OUTPUT_VARIABLE GCC_VERSION)
  IF (APPLE_OPENMP_SUCKS AND GCC_VERSION VERSION_LESS 4.6.2)
    MESSAGE(STATUS "Warning: Disabling OpenMP (unstable with this version of GCC)")
    MESSAGE(STATUS " Install GCC >= 4.6.2 or change your OS to enable OpenMP")
    SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-unknown-pragmas")
    SET(WITH_OPENMP OFF CACHE BOOL "OpenMP support if available?" FORCE)
  ENDIF ()
ENDIF ()

IF (WITH_OPENMP)
  FIND_PACKAGE(OpenMP)
  IF(OPENMP_FOUND)
    MESSAGE(STATUS "Compiling with OpenMP support")
    SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${OpenMP_C_FLAGS}")
    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")
    SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${OpenMP_EXE_LINKER_FLAGS}")
  ENDIF(OPENMP_FOUND)
ENDIF (WITH_OPENMP)

SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=c99")

SET(src ppm.c)
ADD_TORCH_PACKAGE(ppm "${src}" "${luasrc}" "Image Processing")
TARGET_LINK_LIBRARIES(ppm luaT TH)
IF(LUALIB)
  TARGET_LINK_LIBRARIES(ppm ${LUALIB})
ENDIF()

if (JPEG_FOUND)
    SET(src jpeg.c)
    include_directories (${JPEG_INCLUDE_DIR})
    SET(CMAKE_REQUIRED_INCLUDES "${JPEG_INCLUDE_DIR}")
    SET(CMAKE_REQUIRED_LIBRARIES "${JPEG_LIBRARY}")
    INCLUDE(CheckSymbolExists)
    CHECK_SYMBOL_EXISTS(jpeg_mem_src "stddef.h;stdio.h;jpeglib.h" HAVE_JPEG_MEM_SRC)
    IF (HAVE_JPEG_MEM_SRC)
      SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DHAVE_JPEG_MEM_SRC")
    ENDIF (HAVE_JPEG_MEM_SRC)
    CHECK_SYMBOL_EXISTS(jpeg_mem_dest "stddef.h;stdio.h;jpeglib.h" HAVE_JPEG_MEM_DEST)
    IF (HAVE_JPEG_MEM_DEST)
      SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DHAVE_JPEG_MEM_DEST")
    ENDIF (HAVE_JPEG_MEM_DEST)
    ADD_TORCH_PACKAGE(jpeg "${src}" "${luasrc}" "Image Processing")
    TARGET_LINK_LIBRARIES(jpeg luaT TH ${JPEG_LIBRARIES})
    IF(LUALIB)
        TARGET_LINK_LIBRARIES(jpeg ${LUALIB})
    ENDIF()
else (JPEG_FOUND)
    message ("WARNING: Could not find JPEG libraries, JPEG wrapper will not be installed")
endif (JPEG_FOUND)

if (PNG_FOUND)
    SET(src png.c)
    include_directories (${PNG_INCLUDE_DIR})
    ADD_TORCH_PACKAGE(lua_png "${src}" "${luasrc}" "Image Processing")
    TARGET_LINK_LIBRARIES(lua_png luaT TH ${PNG_LIBRARIES})
    IF(LUALIB)
        TARGET_LINK_LIBRARIES(lua_png ${LUALIB})
    ENDIF()
else (PNG_FOUND)
    message ("WARNING: Could not find PNG libraries, PNG wrapper will not be installed")
endif (PNG_FOUND)

SET(src image.c)
SET(luasrc init.lua win.ui test/test.lua)

ADD_TORCH_PACKAGE(image "${src}" "${luasrc}" "Image Processing")
TARGET_LINK_LIBRARIES(image luaT TH)
IF(LUALIB)
  TARGET_LINK_LIBRARIES(image ${LUALIB})
ENDIF()
INSTALL(DIRECTORY "assets" DESTINATION "${Torch_INSTALL_LUA_PATH_SUBDIR}/image")
INSTALL(FILES "README.md" DESTINATION "${Torch_INSTALL_LUA_PATH_SUBDIR}/image")

## lua-torch-image 0~20170420-g5aa1881

=== debian/changelog ===
lua-torch-image (0~20170420-g5aa1881-5) unstable; urgency=medium

  * Update Autopkgtest files. Discard the tput error.

 -- Mo Zhou <cdluminate@gmail.com>  Sun, 29 Oct 2017 05:20:05 +0000

lua-torch-image (0~20170420-g5aa1881-4) unstable; urgency=medium

  * This package doesn't FTBFS anymore with updated lua-torch-torch7
    package. (Closes: #877131)
  * Upload to unstable.

 -- Mo Zhou <cdluminate@gmail.com>  Sat, 28 Oct 2017 13:26:29 +0000

lua-torch-image (0~20170420-g5aa1881-3) experimental; urgency=medium

  * Bump Standards-Version to 4.1.1 .
    + Use https link in copyright.
  * Update my name in control and copyright.
  * Add Autopkgtest control file.

 -- Mo Zhou <cdluminate@gmail.com>  Fri, 27 Oct 2017 01:39:33 +0000

lua-torch-image (0~20170420-g5aa1881-2) experimental; urgency=medium

  * Only build on architectures that are supported by upstream.
    supported: amd64 arm64 armel armhf ppc64el kfreebsd-amd64

 -- Zhou Mo <cdluminate@gmail.com>  Mon, 22 May 2017 03:21:54 +0000

lua-torch-image (0~20170420-g5aa1881-1) experimental; urgency=medium

  * Import upstream snapshot.
  * Debhelper compat 10.
  * Upstream renamed libpng.so -> liblua_png.so .
  * Remove -pedantic option from rules.

 -- Zhou Mo <cdluminate@gmail.com>  Sat, 20 May 2017 09:00:59 +0000

lua-torch-image (0~20161010-g674c8d1-1) experimental; urgency=medium

  * New upstream snapshot.
  * Install upstream test scripts as examples.

 -- Zhou Mo <cdluminate@gmail.com>  Thu, 17 Nov 2016 09:28:15 +0000

lua-torch-image (0~20160730-g797fcb1-1) experimental; urgency=low

  * Initial release. Closes: #827434

 -- Zhou Mo <cdluminate@gmail.com>  Sun, 28 Aug 2016 05:13:58 +0000

=== debian/control ===
Source: lua-torch-image
Section: interpreters
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Mo Zhou <cdluminate@gmail.com>
Build-Depends: debhelper (>=10),
               dh-lua,
               luajit,
               libtorch-th-dev,
               libtorch-luat-dev,
               lua-torch-torch7,
               lua-torch-xlua,
               lua-torch-sys,
               lua-torch-dok,
               libjpeg-dev,
               libpng-dev,
Standards-Version: 4.1.1
Homepage: https://github.com/torch/image
Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/lua-torch-image.git
Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/lua-torch-image.git

# Architecture Note:
# https://github.com/torch/torch7/issues/762#issuecomment-271497176
# supported: amd64 arm64 armel armhf ppc64el kfreebsd-amd64

Package: lua-torch-image
Architecture: amd64 arm64 armel armhf ppc64el kfreebsd-amd64
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
         lua-torch-torch7,
         lua-torch-xlua,
         lua-torch-sys,
         lua-torch-dok,
Description: Image Load/Save Library for Torch Framework
 "image" is the Torch7 distribution package for processing images. It
 contains a wide variety of functions divided into the following categories:
 .
  * Saving and loading images as JPEG, PNG, PPM and PGM;
  * Simple transformations like translation, scaling and rotation;
  * Parameterized transformations like convolutions and warping;
  * Simple Drawing Routines like drawing text or a rectangle on an image;
  * Graphical user interfaces like display and window;
  * Color Space Conversions from and to RGB, YUV, Lab, and HSL;
  * Tensor Constructors for creating Lenna, Fabio and Gaussian and
    Laplacian kernels;
 .
 Note that unless specified otherwise, this package deals with images of
 size `nChannel x height x width`.

=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS= hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@ --buildsystem=lua --with lua

override_dh_auto_configure:
	ln -s . image
	dh_auto_configure

override_dh_auto_test:
	-$(RM) -rf deb.test
	set -e; mkdir -p deb.test/image;
	set -e; find . -type f,l -name '*.so*' -exec cp -vL '{}' deb.test/ \; ;
	set -e; find . -type f -name '*.lua' -exec cp -v '{}' deb.test/image \; ;
	set -e; cp -av assets deb.test/image/; \
		ln -s image/assets deb.test/assets;
	set -e; cd deb.test; ln -s image/init.lua image.lua; \
		ln -s libimage.so libppm.so; \
		ln -s libimage.so liblua_png.so; \
		ln -s libimage.so libjpeg.so; \
		luajit -limage -e 'image.test()';
	dh_auto_test

override_dh_auto_clean:
	-$(RM) -rf 5.1-torch-image debian/trash image deb.test
	dh_auto_clean

=== debian/tests/control ===
Test-Command: luajit -ltorch -limage -e "os.exit()" 2>/dev/null

Test-Command: luajit -ltorch -limage -e "image.test()" 2>/dev/null

## lua-torch-image 0%7e20161010

=== CMakeLists.txt ===
--- 
+++ 
@@ -69,10 +69,10 @@
 if (PNG_FOUND)
     SET(src png.c)
     include_directories (${PNG_INCLUDE_DIR})
-    ADD_TORCH_PACKAGE(lua_png "${src}" "${luasrc}" "Image Processing")
-    TARGET_LINK_LIBRARIES(lua_png luaT TH ${PNG_LIBRARIES})
+    ADD_TORCH_PACKAGE(png "${src}" "${luasrc}" "Image Processing")
+    TARGET_LINK_LIBRARIES(png luaT TH ${PNG_LIBRARIES})
     IF(LUALIB)
-        TARGET_LINK_LIBRARIES(lua_png ${LUALIB})
+        TARGET_LINK_LIBRARIES(png ${LUALIB})
     ENDIF()
 else (PNG_FOUND)
     message ("WARNING: Could not find PNG libraries, PNG wrapper will not be installed")
